// プログラミング演習1
// 発表会用提出プログラム
// X組 XX番 中村聡史（学生番号 XXXXXXXX）
// 電光掲示板を模倣しているプログラム
// 提出日 2013/07/15

// ライト用の配列の定義
int[][] light = new int [30][10];
// 電光掲示板の1つの横幅
int d = 20;

void setup() {
  // 600x200のウインドウを作成する
  size( 600, 200 );
  // 電光掲示板に初期値をセットする
  // *** ここで配列を使っています ***
  light[4][2] = 1;
  light[5][2] = 1;
  light[6][2] = 1;
  light[3][3] = 1;
  light[3][4] = 1;
  light[4][5] = 1;
  light[5][5] = 1;
  light[6][6] = 1;
  light[6][7] = 1;
  light[5][8] = 1;
  light[4][8] = 1;
  light[3][8] = 1;
  light[9][2] = 1;
  light[9][3] = 1;
  light[9][4] = 1;
  light[9][5] = 1;
  light[9][6] = 1;
  light[9][7] = 1;
  light[9][8] = 1;
  light[10][5] = 1;
  light[11][5] = 1;
  light[12][5] = 1;
  light[13][2] = 1;
  light[13][3] = 1;
  light[13][4] = 1;
  light[13][5] = 1;
  light[13][6] = 1;
  light[13][7] = 1;
  light[13][8] = 1;
}

// 1つ1つのライトの関数の定義
// 1つ目の引数はライトのX座標，2つ目の引数はライトのY座標
// 3つ目の引数はライトの直径，4つ目の引数はライトの色のタイプ
void showLight( int lx, int ly, int ld, int lcolor ) {
  stroke( 0 );
  // *** ここで条件分岐を使っています ***
  if ( lcolor == 0 ) {
    // lcolorが0なら白色
    fill(255);
  } else if ( lcolor == 1 ) {
    // lcolorが1なら赤色
    fill(255, 0, 0);
  } else if ( lcolor == 2 ) {
    // lcolorが2なら黄色
    fill(255, 255, 0);
  } else if ( lcolor == 3 ) {
    // lcolorが3なら緑色
    fill(0, 255, 0);
  }
  // 円の中心(lx, ly)に直径ldの円を描く
  ellipse( lx, ly, ld, ld );
}

void draw() {
  // 背景色を白色にする
  background(255);

  // *** ここで繰り返しを使っています ***
  int j=0;
  while (j<10) {   
    int i=0;
    while ( i<30 ) {
      // *** ここで関数を使っています ***
      // *** ここで配列を使っています ***
      // 1つずつのライトを表示する関数
      showLight( i*d+d/2, j*d+d/2, d, light[i][j] );
      i++;
    }
    j++;
  }

  // *** ここで繰り返しを使っています ***
  j=0;
  while (j<10) {   
    int i=0;
    // 一番左のライトの値を一番右に持っていくため一旦保存
    int temp = light[0][j];
    while ( i<29 ) {
      // *** ここで配列を使っています ***
      // 値を右から左にシフトする
      // 右のライトの値を左に代入する
      light[i][j] = light[i+1][j];
      i++;
    }
    // 保存しておいた一番左のライトの色を一番右に代入する
    light[29][j] = temp;
    j++;
  }

  // 1秒の遅延を入れる
  delay(100);
}

// マウス操作により対話的なプログラムにしています
void mousePressed() {
  // 以下で繰り返しを利用
  int j=0;
  while (j<10) {
    int i=0;
    while ( i<29 ) {
      // マウスの座標と，円の中心座標との距離が直径の2分の1の時色を変化させる
      // *** ここで条件分岐を使っています ***
      if ( dist( mouseX, mouseY, d*i+d/2, d*j+d/2 ) < d/2 ) {
        // 色を変化させる場合は数を増やす
        light[i][j]++;
        // 数が3を超えると0に戻す
        if ( light[i][j]>3 ) light[i][j] = 0;
      }
      i++;
    }
    j++;
  }
}

